; +++++++++ Enum Font Families Example +++++++++
; ++ Taken from Donkey's post at MASM32 Forum ++
; ++++++++++ Also with DednDave's help +++++++++
; +++++++ Programmed by Luis Costa +++++++++++++
; ++++++++++ xandaz@hotmai.com +++++++++++++++++
; +++++++++++ Lisbon, Portugal +++++++++++++++++

; +++++ It's kinda sketchy yet / don't click the itens cause it only processes ODA_DRAWENTIRE and its 
; +++++ ready to draw the items only once. Later i'll work on it. For now i want to post

.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
EnumFontFamProc PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ListProc    PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     200
MainWindowHeight    equ     400
lbID                equ     100h
.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'EnumFonts',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ List Box related +++++

hList           dd          ?
ListBoxClass    db      'LISTBOX',0
lbItem          dd          0

; ++++ Scroll related +++++

ScrollClass     db      'SCROLLBAR',0
hScroll         dd          ?

; ++++ others +++++

rect        RECT        <>
hDC         HDC         ?
hMemDC      HDC         ?

lf          LOGFONT     <>
ENUM_FLAG       dd      FALSE
dis         DRAWITEMSTRUCT      <>
szLame      db          ',\lame.bmp',0
hBitmap     dd          ?
iccx        INITCOMMONCONTROLSEX    <sizeof iccx,ICC_STANDARD_CLASSES>
hMem        dd      ?
lpMem       dd      ?
lpCurrentELF    dd      ?
noItems     dd      0

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  InitCommonControlsEx,addr iccx
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG
    

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW+WS_CLIPCHILDREN,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  PeekMessage,addr msg,NULL,0,0,PM_NOREMOVE
    or      eax,eax
    jz      no_msg
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
no_msg:
    cmp     ENUM_FLAG,FALSE
    jne     msg_loop
    invoke  LocalAlloc,LPTR,200*sizeof LOGFONT
    mov     hMem,eax
    invoke  LocalLock,hMem
    mov     lpMem,eax
    mov     lpCurrentELF,eax
    invoke  GetDC,hMainWindow
    mov     hDC,eax
    mov     lf.lfCharSet,ANSI_CHARSET
    mov     lf.lfFaceName,NULL
    mov     lf.lfPitchAndFamily,NULL
    invoke  EnumFontFamiliesEx,hDC,addr lf,addr EnumFontFamProc,hMainWindow,NULL
    mov     esi,lpMem
    mov     ecx,noItems
looper:
    push    ecx
    push    esi
    invoke  SendMessage,hList,LB_ADDSTRING,NULL,esi
    pop     esi
    pop     ecx
    dec     ecx
    jcxz    end_looper
    add     esi,sizeof LOGFONT
    jmp     looper
end_looper:  
    invoke  ReleaseDC,hMainWindow,hDC
    mov     ENUM_FLAG,TRUE
    jmp     msg_loop        


end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC  hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   hFont:DWORD
    local   MemDC:DWORD
        
    .if uMsg==WM_DESTROY

        invoke  PostQuitMessage,NULL
        invoke	LocalFree,hMem
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,NULL,addr ListBoxClass,NULL,WS_VISIBLE+WS_CHILD+LBS_OWNERDRAWVARIABLE\
                            +LBS_DISABLENOSCROLL+WS_VSCROLL\
                        ,0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL ;cst
            mov     hList,eax
        .endif           
    .elseif uMsg==WM_MEASUREITEM
        mov     edi,lParam
        assume  edi:PTR MEASUREITEMSTRUCT
        mov     [edi].itemHeight,18
        push    rect.right
        pop     [edi].itemWidth 
         
    .elseif uMsg==WM_DRAWITEM      
      ;  invoke  Beep,200,20
        mov     edi,lParam
        assume  edi:PTR DRAWITEMSTRUCT
            mov     esi,[edi].itemData
            assume  esi:PTR LOGFONT 
            mov     [esi].lfEscapement,0
            mov     [esi].lfHeight,16
            mov     [esi].lfWidth,8
            invoke  CreateFontIndirect,esi
            mov     hFont,eax
            invoke  SelectObject,[edi].hdc,hFont
            test    [edi].itemAction,ODA_DRAWENTIRE
            jnz     simple_draw
            test    [edi].itemState,ODS_SELECTED
            jz      simple_draw
            invoke  SetBkColor,[edi].hdc,0ffh
            invoke  SetTextColor,[edi].hdc,0ff0000h            
simple_draw:
            invoke  DrawText,[edi].hdc,addr [esi].lfFaceName,-1,addr [edi].rcItem,DT_LEFT
            invoke  DeleteObject,hFont
            assume  esi:NOTHING
            assume  edi:NOTHING
          ;  .endif
        .else
            invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
            ret
        .endif
        xor eax,eax
        ret
WndProc     endp
    
EnumFontFamProc PROC  lpEnumLogFontEx:LPSTR,lpTextMetric:LPSTR,FontType:DWORD,lParam:DWORD
    
        push    ecx
        push    esi
        push    edi
        pushfd
   .if FontType==TRUETYPE_FONTTYPE
        mov ecx,sizeof LOGFONT
        cld
        mov     esi,lpEnumLogFontEx
        assume  esi:PTR ENUMLOGFONTEX
        lea     esi,[esi].elfLogFont
        mov     edi,lpCurrentELF
looper:
        movsb
        dec     ecx
        jcxz    end_looper
        jmp     looper
end_looper:        
        assume  esi:NOTHING
        mov     lpCurrentELF,edi
        inc     noItems
   .endif

    popfd
    pop     edi
    pop     esi
    pop     ecx
    mov eax,TRUE
    ret
    
EnumFontFamProc endp    

ListProc    PROC    uses edi esi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    ret

ListProc    endp

end start
                                    
